
my $file = shift @ARGV;
my $size = shift @ARGV;
my $blocksize = shift @ARGV;

print "Params: $file $size $blocksize\n";
my $rsize = 0;
my @array;

if (open OUT, "$file") {
    my $nread = 0;
    
    while ($rsize < $size) {
	my $nblocks = $size/$blocksize;
	for ( my $i=0; $i < $nblocks; $i++) {
	    my $offset = $i * $blocksize;
	    my $length = $blocksize;
	    # the last block might be shorter
	    if (($offset + $length) > $size) { $length = $size - $offset;}
	    # cycle over the 1M buffer
	    my $bread = sysread OUT, $buff, $length, $offset;
#	    print "wrote $bwrite\n";
	    if ($bread>0) {$nread += $bread;}
	}
	if (($nread != $size) ) {
	    die "error: read error - file probably too short";
	}
	$rsize += $nread;
    }
}
close (OUT);
