
my $file = shift @ARGV;
my $size = shift @ARGV;
my $blocksize = shift @ARGV;

print "Params: $file $size $blocksize\n";
my $wsize = 0;
my @array;
my $meg = 1024*1024;

# prepare buffer
#for (my $i=0; $i< $meg; $i++) {
#    $arrav[$i] = $i%255;
#}
$array[$meg] = 1;

my $buff = pack("c$meg",@array);

if (open OUT, ">$file") {
    my $nwrite = 0;
    
    while ($wsize < $size) {
	my $nblocks = $size/$blocksize;
	for ( my $i=0; $i < $nblocks; $i++) {
	    my $offset = $i * $blocksize;
	    my $length = $blocksize;
	    # the last block might be shorter
	    if (($offset + $length) > $size) { $length = $size - $offset;}
	    # cycle over the 1M buffer
	    $offset%=$meg;
#	    print "length $length $offset\n";
	    my $bwrite = syswrite OUT, $buff, $length, $offset;
#	    print "wrote $bwrite\n";
	    if ($bwrite>0) {$nwrite += $bwrite;}
	}
	if (( $nwrite != $meg) && ($nwrite != $size) ) {
	    die "error: write error";
	}
	$wsize += $nwrite;
    }
}
close (OUT);
